<?php
/**
 * @version    CVS: 1.0.0
 * @package    com_miniorangesociallogin
 * @author     miniOrange Security Software Pvt. Ltd. <info@xecurify.com>
 * @copyright  Copyright 2015 miniOrange. All Rights Reserved.
 * @license    GNU/GPLv3
 */

// No direct access
defined( '_JEXEC' ) or die;

jimport( 'joomla.application.component.controllerform' );

/**
 * Myaccount controller class.
 *
 * @since  1.6
 */
 

class MiniorangesocialloginControllerMyaccount extends JControllerForm {
	function __construct() {
		$this->view_list = 'myaccounts';
		parent::__construct();
	}


	function toggleSocialApp(){
		if(!$this->isCustomerRegistered()){
			$this->setRedirect('index.php?option=com_miniorangesociallogin','Register/Login to configure social login','error');
			return;
		}
		$app = JFactory::getApplication();
		$post = $app->input->post->getArray();
		$isActive=FALSE;
		if($post['mo_app_is_active']=='1'){
			$isActive=TRUE;
		}
		$freeApps = array('google','linkedin','facebook','yahoo','twitter');
		$appName = $post['mo_app_name'];
		if(!in_array($appName, $freeApps)){
		 	$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=licensing','Upgrade to save configurations','Error');
		 	return;
		    
		}
		if( $isActive && !$this->isAppConfigured($appName) ){

			$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=google_app&configure='.$appName,'You have not Configured '.ucfirst($appName),'Warning:');
			return;
		}


		$updateArray=array('active'=>$isActive);
		$this->updateSocialAppDatabase($appName,$updateArray);
		$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=google_app',ucfirst($post['mo_app_name']).' is '.($isActive?'activated.':'deactivated.'),'success');
	}

	function isAppConfigured($appName){
		 $db = JFactory::getDbo();

        $query = $db->getQuery( true );
        $query
            ->select('a.*')
            ->from($db->quoteName('#__miniorangesociallogin_apps_data','a'))
            ->where($db->quoteName('appName') . '=' . $db->quote($appName));
            
        $db->setQuery($query);
        $result = $db->loadAssoc();
        if(is_array($result) ){
        	if(!empty($result['clientId']) && !empty($result['clientSecret']))
        	{
        		return true;
        	}
        	else if($result['preconfigured']=='1'){
        		return true;
        	}
        }
        return false;

	}


	function updateSocialAppDatabase($appName,$updateArray){
		
		$db = JFactory::getDbo();

		$query = $db->getQuery( true );
		$query
    		->select('a.*')
    		->from($db->quoteName('#__miniorangesociallogin_apps_data','a'))
    		->where($db->quoteName('appName') . '=' . $db->quote($appName));
    	$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$result = $db->loadAssoc();

		if(!is_array($result)){
			// there is no row with $appName so insert one
			// Create a new query object.
			$query = $db->getQuery(true);
			// Insert columns.
			$columns = array('appName');
			// Insert values.
			$values = array($db->quote($appName));

			// Prepare the insert query.
			$query
    			->insert($db->quoteName('#__miniorangesociallogin_apps_data'))
    			->columns($db->quoteName($columns))
   	 			->values(implode(',', $values));

			// Set the query using our newly populated query object and execute it.
			$db->setQuery($query);
			
			$db->execute();
		}
		$preconfigured = $result['preconfigured'];
		$clientId      = $result['clientId'];
		$clientSecret = $result['clientSecret'];
		if(isset($updateArray['preconfigured'])){
			$preconfigured = $updateArray['preconfigured'];
		}
		if(isset($updateArray['clientId'])){
			$clientId = $updateArray['clientId'];
		}
		if(isset($updateArray['clientSecret'])){
			$clientSecret = $updateArray['clientSecret'];
		}
		if($preconfigured=='0' && (empty($clientId) || empty($clientSecret)))
        {
        		$updateArray['active']='0';
        }
        
		$query = $db->getQuery(true);
		$fields = array();
		foreach ($updateArray as $key => $value) {
			array_push($fields,$db->quoteName($key) . ' = ' . $db->quote($value));
		}

		$conditions = array(
			$db->quoteName('appName') . ' ='.$db->quote($appName), 
		);

		$query->update($db->quoteName('#__miniorangesociallogin_apps_data'))->set($fields)->where($conditions);

		$db->setQuery($query);
		$result = $db->execute();

		
	}
	function saveAppConfig(){
		if(!$this->isCustomerRegistered()){
			$this->setRedirect('index.php?option=com_miniorangesociallogin','Register/Login to configure social login','error');
			return;
		}
		$app = JFactory::getApplication();
		$post = $app->input->post->getArray();

		 $appName  = $post['google_custom_app_name'];
		 $freeApps = array('google','linkedin','facebook','yahoo','twitter');
		if(!in_array($appName, $freeApps)){
		 	$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=licensing','Upgrade to save configurations','Error');
		 	return;
		    
		}
		 
		
		
		 $client_id = $post['app_client_id'];
		 $client_Secret = $post['app_client_Secret'];
		 $appScope = $post['app_scope'];
		 $updateArray = array('clientId'=>$client_id,'clientSecret'=>$client_Secret,'scope'=>$appScope);
		 $this->updateSocialAppDatabase($appName,$updateArray);
		 $this->setRedirect('index.php?option=com_miniorangesociallogin&tab=google_app&configure='.$appName,'Configurations saved successfully. ','success');
	

	}
	function updatePreconfigureAppSettings(){
		if(!$this->isCustomerRegistered()){
			$this->setRedirect('index.php?option=com_miniorangesociallogin','Register/Login to configure social login','error');
			return;
		}
		$app = JFactory::getApplication();
		$post = $app->input->post->getArray();
		$updateArray = array('preconfigured'=>$post['mo_enable_preconfigured_app']);
		$appName = $post['enablePreconfiguredForAppName'] ;
		$freeApps = array('google','linkedin','facebook','yahoo','twitter');
		if(!in_array($appName, $freeApps)){
		 	$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=licensing','Upgrade to save configurations','Error');
		 	return;
		    
		}
		
		$this->updateSocialAppDatabase($appName,$updateArray);
		$this->setRedirect('index.php?option=com_miniorangesociallogin&tab=google_app&configure='.$appName,'Configurations saved successfully. ','success');
	}

	function isCustomerRegistered(){
		$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('*');
    	$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
    	$query->where($db->quoteName('id') . " = 1");
    	$db->setQuery($query);
    	$result = $db->loadAssoc();
       
    
    	if(isset($result['customer_token']) && !empty($result['customer_token']) & isset($result['customer_key']) && !empty($result['customer_key'])){
       	return TRUE;
    	}
    	return FALSE;
	}











	//-------------------------

	function verifyCustomer() {
		$post = JRequest::get( 'post' );

		$email    = '';
		$password = '';

		if ( Mo_Sociallogin_Local_Util::check_empty_or_null( $post['email'] ) || Mo_Sociallogin_Local_Util::check_empty_or_null( $post['password'] ) ) {
			JError::raiseError( 4711, 'All the fields are required. Please enter valid entries.' );

			return;
		} else {
			$email    = $post['email'];
			$password = $post['password'];
		}

		$db = JFactory::getDbo();

		$query = $db->getQuery( true );
		// Fields to update.
		$fields = array(
			$db->quoteName( 'email' ) . ' = ' . $db->quote( $email ),
			$db->quoteName( 'password' ) . ' = ' . $db->quote( $password ),
		);

		// Conditions for which records should be updated.
		$conditions = array(
			$db->quoteName( 'id' ) . ' = 1'
		);

		$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
		$db->setQuery( $query );
		$result = $db->execute();

		$customer = new Mo_Sociallogin_Local_Customer();
		$content  = $customer->get_customer_key();

		$customerKey = json_decode( $content, true );
		if ( strcasecmp( $customerKey['apiKey'], 'CURL_ERROR' ) == 0 ) {
		
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $customerKey['token'], 'error' );
		} else if ( json_last_error() == JSON_ERROR_NONE ) {
			
			$this->save_success_customer_config( $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone'], 'Your account has been retrieved successfully.' );
			
		} else {
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Invalid username or password. Please try again.', 'error' );
			
		}
					

	}

	/*
	 * Save all required fields on customer registration/retrieval complete.
	 */
	function save_success_customer_config( $id, $apiKey, $token, $phone, $msg ) {

		$db = JFactory::getDbo();

		$query = $db->getQuery( true );
		// Fields to update.
		$fields = array(
			$db->quoteName( 'customer_key' ) . ' = ' . $db->quote( $id ),
			$db->quoteName( 'api_key' ) . ' = ' . $db->quote( $apiKey ),
			$db->quoteName( 'customer_token' ) . ' = ' . $db->quote( $token ),
			$db->quoteName( 'admin_phone' ) . ' = ' . $db->quote( $phone ),
			$db->quoteName( 'login_status' ) . ' = ' . $db->quote( false ),
			$db->quoteName( 'new_registration' ) . ' = ' . $db->quote( false ),
			$db->quoteName( 'registration_status' ) . ' = NULL'
		);

		// Conditions for which records should be updated.
		$conditions = array(
			$db->quoteName( 'id' ) . ' = 1'
		);

		$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
		$db->setQuery( $query );
		$result = $db->execute();

		$query = $db->getQuery( true );
		

		

		$erMsg = 'Your account has been retrieved successfully.';

		$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $erMsg );
		
	}


	function saveConfig() {


		if ( isset( $_POST['option1'] ) && $_POST['option1'] == "mo_sociallogin_save_config" ) {
			
			$db    = JFactory::getDbo();
			$query = $db->getQuery( true );
			$query->select( '*' );
			$query->from( $db->quoteName( '#__miniorangesociallogin_apps_save' ) );
			$query->where( $db->quoteName( 'id' ) . " = 1" );

			$db->setQuery( $query );
			$default_config = $db->loadAssoc();

			$fields = array(
				$db->quoteName( 'fenable' ) . ' = ' . $db->quote( isset( $_POST['fenable'] ) ? $_POST['fenable'] : 0 ),
				$db->quoteName( 'tenable' ) . ' = ' . $db->quote( isset( $_POST['tenable'] ) ? $_POST['tenable'] : 0 ),
				$db->quoteName( 'genable' ) . ' = ' . $db->quote( isset( $_POST['genable'] ) ? $_POST['genable'] : 0 ),
				$db->quoteName( 'lenable' ) . ' = ' . $db->quote( isset( $_POST['lenable'] ) ? $_POST['lenable'] : 0 ),
				$db->quoteName( 'ienable' ) . ' = ' . $db->quote( isset( $_POST['ienable'] ) ? $_POST['ienable'] : 0 ),
				$db->quoteName( 'venable' ) . ' = ' . $db->quote( isset( $_POST['venable'] ) ? $_POST['venable'] : 0 ),
				$db->quoteName( 'round_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_shape'] ) ? $_POST['mo_shape'] : 0 ),
				$db->quoteName( 'roundedge_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_shape'] ) ? $_POST['mo_shape'] : 0 ),
				$db->quoteName( 'square_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_shape'] ) ? $_POST['mo_shape'] : 0 ),
				$db->quoteName( 'longbutton_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_shape'] ) ? $_POST['mo_shape'] : 0 ),
				$db->quoteName( 'default_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_background'] ) ? $_POST['mo_background'] : 0 ),
				$db->quoteName( 'custom_enable' ) . ' = ' . $db->quote( isset( $_POST['mo_background'] ) ? $_POST['mo_background'] : 0 ),
				$db->quoteName( 'icon_size' ) . ' = ' . $db->quote( isset( $_POST['mo_login_icon_custom_size'] ) ? $_POST['mo_login_icon_custom_size'] : 0 ),
				$db->quoteName( 'icon_width' ) . ' = ' . $db->quote( isset( $_POST['mo_login_icon_custom_width'] ) ? $_POST['mo_login_icon_custom_width'] : 0 ),
				$db->quoteName( 'icon_height' ) . ' = ' . $db->quote( isset( $_POST['mo_login_icon_custom_height'] ) ? $_POST['mo_login_icon_custom_height'] : 0 ),
				$db->quoteName( 'icon_curve' ) . ' = ' . $db->quote( isset( $_POST['mo_login_icon_custom_curve'] ) ? $_POST['mo_login_icon_custom_curve'] : 0 ),
				$db->quoteName( 'background_color' ) . ' = ' . $db->quote( isset( $_POST['mo_login_icon_custom_color'] ) ? $_POST['mo_login_icon_custom_color'] : 0 )
			);

			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_apps_save' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			
			$message      = 'Your configuration has been saved successfully.';
			$status = "success";
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin&tab=social_login', $message, $status );

		} else if ( isset( $_POST['custom_app_option'] ) && $_POST['custom_app_option'] == "mo_sociallogin_custom_app" ) {

		
	
			$db    = JFactory::getDbo();
			$query = $db->getQuery( true );
			$query->select( '*' );
			$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
			$query->where( $db->quoteName( 'id' ) . " = 1" );

			$db->setQuery( $query );
			$default_config = $db->loadAssoc();
			
			

			// Fields to update.
			$fields = array(
				$db->quoteName( 'client_id' ) . ' = ' . $db->quote( isset( $_POST['client_id'] ) ? trim($_POST['client_id']) : 0 ),
				$db->quoteName( 'client_Secret' ) . ' = ' . $db->quote( isset( $_POST['client_Secret'] ) ? trim($_POST['client_Secret']) : 0 ),
			);
			

			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$message      = 'Your configuration has been saved successfully.';
			
			$status       = 'success';
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin&tab=Custom_app', $message );

		} else if(isset( $_POST['google_custom_app_option'] ) && $_POST['google_custom_app_option'] == "mo_sociallogin_google_custom_app"){

			$db    = JFactory::getDbo();
			$query = $db->getQuery( true );
			$query->select( '*' );
			$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
			$query->where( $db->quoteName( 'id' ) . " = 1" );

			$db->setQuery( $query );
			$default_config = $db->loadAssoc();



			// Fields to update.
			$fields = array(
				$db->quoteName( 'google_client_id' ) . ' = ' . $db->quote( isset( $_POST['google_client_id'] ) ? trim($_POST['google_client_id']) : 0 ),
				$db->quoteName( 'google_client_Secret' ) . ' = ' . $db->quote( isset( $_POST['google_client_Secret'] ) ? trim($_POST['google_client_Secret']) : 0 ),
			);



			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();

			$message      = 'Your configuration has been saved successfully.';

			$status       = 'success';
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin&tab=google_app', $message );

		}else if(isset( $_POST['twitter_custom_app_option'] ) && $_POST['twitter_custom_app_option'] == "mo_sociallogin_twitter_custom_app"){

			$db    = JFactory::getDbo();
			$query = $db->getQuery( true );
			$query->select( '*' );
			$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
			$query->where( $db->quoteName( 'id' ) . " = 1" );

			$db->setQuery( $query );
			$default_config = $db->loadAssoc();



			// Fields to update.
			$fields = array(
				$db->quoteName( 'twitter_client_id' ) . ' = ' . $db->quote( isset( $_POST['twitter_client_id'] ) ? trim($_POST['twitter_client_id']) : 0 ),
				$db->quoteName( 'twitter_client_Secret' ) . ' = ' . $db->quote( isset( $_POST['twitter_client_Secret'] ) ? trim($_POST['twitter_client_Secret']) : 0 ),
			);



			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			
			$message      = 'Your configuration has been saved successfully.';

			$status       = 'success';
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin&tab=twitter_app', $message );

		}
	}

    function sendQuery() {
        $url =  'https://login.xecurify.com/moas/api/notify/send';
        $ch = curl_init($url);
        $email = $_POST['query_email'];
        $phone = $_POST['phone'];
        $query = $_POST['query'];

        $customerKey = "16555";
        $apiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";


        $currentTimeInMillis= round(microtime(true) * 1000);
        $stringToHash 		= $customerKey .  number_format($currentTimeInMillis, 0, '', '') . $apiKey;
        $hashValue 			= hash("sha512", $stringToHash);
        $customerKeyHeader 	= "Customer-Key: " . $customerKey;
        $timestampHeader 	= "Timestamp: " .  number_format($currentTimeInMillis, 0, '', '');
        $authorizationHeader= "Authorization: " . $hashValue;
        $fromEmail 			= $email;
        $subject            = "MiniOrange Joomla Support Query for Social Login ";


        $query1 =" MiniOrange Joomla [Free] Social Login Support Request";
        $content='<div >Hello, <br><br>Company :<a href="'.$_SERVER['SERVER_NAME'].'" target="_blank" >'.$_SERVER['SERVER_NAME'].'</a><br><br>Phone Number :'.$phone.'<br><br><b>Email :<a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a></b><br><br><b>Support Query: '.$query1. '</b><br><br><b>Reason: ' .$query. '</b></div>';

        //$test_email_id = ''; for testing purposes
        $support_email_id = 'joomlasupport@xecurify.com';

        $fields = array(
            'customerKey'	=> $customerKey,
            'sendEmail' 	=> true,
            'email' 		=> array(
                'customerKey' 	=> $customerKey,
                'fromEmail' 	=> $fromEmail,
                'bccEmail' 		=> $support_email_id,
                'fromName' 		=> 'miniOrange',
                'toEmail' 		=> $support_email_id,
                'toName' 		=> $support_email_id,
                'subject' 		=> $subject,
                'content' 		=> $content
            ),
        );
        $field_string = json_encode($fields);


        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
        curl_setopt( $ch, CURLOPT_ENCODING, "" );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );    # required for https urls

        curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customerKeyHeader,
            $timestampHeader, $authorizationHeader));
        curl_setopt( $ch, CURLOPT_POST, true);
        curl_setopt( $ch, CURLOPT_POSTFIELDS, $field_string);
        $content = curl_exec($ch);

        if(curl_errno($ch)){
            return json_encode(array("status"=>'ERROR','statusMessage'=>curl_error($ch)));
        }
        curl_close($ch);

        $this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Support query has been sent. We will get back to you shortly.', 'success' );
    }

	function registerCustomer() {
		//validate and sanitize

		$email           = '';
		$phone           = '';
		$password        = '';
		$confirmPassword = '';
		if ( Mo_Sociallogin_Local_Util::check_empty_or_null( $_POST['email'] ) || Mo_Sociallogin_Local_Util::check_empty_or_null( $_POST['password'] ) || Mo_Sociallogin_Local_Util::check_empty_or_null( $_POST['confirmPassword'] ) ) {
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'All the fields are required. Please enter valid entries.', 'error' );

			return;
		} else if ( strlen( $_POST['password'] ) < 6 || strlen( $_POST['confirmPassword'] ) < 6 ) {    //check password is of minimum length 6
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Choose a password with minimum length 6.', 'error' );

			return;
		} else {
			$email           = $_POST['email'];
			$phone           = $_POST['phone'];
			$password        = $_POST['password'];
			$confirmPassword = $_POST['confirmPassword'];
		}

		//update_option( 'mo_sociallogin_local_admin_email', $email );
		$db    = JFactory::getDbo();
		$query = $db->getQuery( true );
		// Fields to update.
		$fields = array(
			$db->quoteName( 'email' ) . ' = ' . $db->quote( $email )
		);

		// Conditions for which records should be updated.
		$conditions = array(
			$db->quoteName( 'id' ) . ' = 1'
		);

		$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
		$db->setQuery( $query );
		$result = $db->execute();

		if ( $phone != '' ) {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'admin_phone' ) . ' = ' . $db->quote( $phone )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
		}


		if ( strcmp( $password, $confirmPassword ) == 0 ) {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'password' ) . ' = ' . $db->quote( $password )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();

			$customer = new Mo_Sociallogin_Local_Customer();
			$content  = json_decode( $customer->check_customer( $email ), true );
			
			if ( strcasecmp( $content['status'], 'TRANSACTION_LIMIT_EXCEEDED' ) == 0 ){
				$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'You have tried logging in multiple times. Please try after some time or contact us at <a href="mailto:joomlasupport@xecurify.com">joomlasupport@xecurify.com</a>','warning' );
				return;

			}
			if ( strcasecmp( $content['status'], 'CUSTOMER_NOT_FOUND' ) == 0 ) {
				$auth_type = 'EMAIL';
				$content   = json_decode( $customer->send_otp_token( $auth_type, null ), true );
				if ( strcasecmp( $content['status'], 'SUCCESS' ) == 0 ) {
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'email_count' ) . ' = ' . $db->quote( 1 ),
						$db->quoteName( 'transaction_id' ) . ' = ' . $db->quote( $content['txId'] ),
						$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_SUCCESS' )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();

					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'A One Time Passcode has been sent <b>( 1 )</b> to <b>' . $email . '</b>. Please enter the OTP below to verify your email. ' );


				} else {
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_FAILURE' )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();

					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'There was an error in sending email. Please click on Resend OTP to try again. ', 'error' );


				}
			} else if ( strcasecmp( $content['status'], 'CURL_ERROR' ) == 0 ) {
				$db     = JFactory::getDbo();
				$query  = $db->getQuery( true );
				$fields = array(
					$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_FAILURE' )
				);
				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName( 'id' ) . ' = 1'
				);

				$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
				$db->setQuery( $query );
				$result = $db->execute();

				$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $content['statusMessage'], 'error' );

			} else {
				$content     = $customer->get_customer_key();
				$customerKey = json_decode( $content, true );
				if ( json_last_error() == JSON_ERROR_NONE ) {
					$this->save_success_customer_config( $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone'], 'Your account has been retrieved successfully.' );
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'password' ) . ' = ' . $db->quote( '' )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();
					//update_option('mo_sociallogin_local_password', '');
				} else {
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'login_status' ) . ' = ' . $db->quote( true ),
						$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( '' )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();

					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'You already have an account with miniOrange. Please enter a valid password. ', 'error' );

				}
			}

		} else {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'login_status' ) . ' = ' . $db->quote( false )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Password and Confirm password do not match.', 'error' );
		}
	}

	function validateOtp() {
		//validation and sanitization
		$otp_token = '';
		if ( Mo_Sociallogin_Local_Util::check_empty_or_null( $_POST['otp_token'] ) ) {

			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_VALIDATION_FAILURE' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Please enter a value in otp field.', 'error' );

			return;
		} else {
			$otp_token = $_POST['otp_token'];
		}


		$db    = JFactory::getDbo();
		$query = $db->getQuery( true );
		$query->select( 'transaction_id' );
		$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
		$query->where( $db->quoteName( 'id' ) . " = 1" );

		$db->setQuery( $query );
		$transaction_id = $db->loadResult();

		$customer = new Mo_Sociallogin_Local_Customer();
		$content  = json_decode( $customer->validate_otp_token( $transaction_id, $otp_token ), true );
		if ( strcasecmp( $content['status'], 'SUCCESS' ) == 0 ) {
			$customer    = new Mo_Sociallogin_Local_Customer();
			$customerKey = json_decode( $customer->create_customer(), true );
			$db          = JFactory::getDbo();
			$query       = $db->getQuery( true );
			$fields      = array(
				$db->quoteName( 'email_count' ) . ' = ' . $db->quote( '' ),
				$db->quoteName( 'sms_count' ) . ' = ' . $db->quote( '' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);
			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();


			if ( strcasecmp( $customerKey['status'], 'CUSTOMER_USERNAME_ALREADY_EXISTS' ) == 0 ) {    //admin already exists in miniOrange
				$content     = $customer->get_customer_key();
				$customerKey = json_decode( $content, true );
				if ( json_last_error() == JSON_ERROR_NONE ) {
					$this->save_success_customer_config( $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone'], 'Your account has been retrieved successfully.' );
				} else {
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'login_status' ) . ' = ' . $db->quote( true ),
						$db->quoteName( 'new_registration' ) . ' = ' . $db->quote( false ),
						$db->quoteName( 'password' ) . ' = ' . $db->quote( '' ),
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();

					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'You already have an account with miniOrange. Please enter a valid password.', 'error' );

				}
			} else if ( strcasecmp( $customerKey['status'], 'SUCCESS' ) == 0 ) {
				$db     = JFactory::getDbo();
				$query  = $db->getQuery( true );
				$fields = array(
					$db->quoteName( 'password' ) . ' = ' . $db->quote( '' ),
				);
				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName( 'id' ) . ' = 1'
				);

				$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
				$db->setQuery( $query );
				$result = $db->execute();
				//registration successful
				$this->save_success_customer_config( $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone'], 'Registration complete!' );
				$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Your account has been created successfully', 'success' );
				return;
			}else if(strcmp( $customerKey['message'], 'Email is not enterprise email.')==0){
			
							$db = JFactory::getDbo();
							$query = $db->getQuery(true);
							$fields = array(
							$db->quoteName('registration_status') . ' = ' . $db->quote(''),
							$db->quoteName('email') . ' = ' . $db->quote(''),
							$db->quoteName('password') . ' = ' . $db->quote(''),
							$db->quoteName('transaction_id') . ' = ' . $db->quote(''),
							);
							// Conditions for which records should be updated.
							$conditions = array(
								$db->quoteName('id') . ' = 1'
							);
							 
							$query->update($db->quoteName('#__miniorangesociallogin_customer_details'))->set($fields)->where($conditions);
							$db->setQuery($query);
							$result = $db->execute();
							
							$this->setRedirect('index.php?option=com_miniorangesociallogin','There was an error creating an account for you. You may have entered an invalid Email-Id. <br><b>(We discourage the use of disposable emails)</b><br>
												Please try again with a valid email.','error');
							
				}
			//update_option('mo_sociallogin_local_password', '');
		} else if ( strcasecmp( $content['status'], 'CURL_ERROR' ) == 0 ) {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_VALIDATION_FAILURE' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $content['statusMessage'], 'error' );

		} else {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_VALIDATION_FAILURE' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Invalid one time passcode. Please enter a valid otp.', 'error' );

		}
	}

	function resendOtp() {
		$customer  = new Mo_Sociallogin_Local_Customer();
		$auth_type = 'EMAIL';
		$content   = json_decode( $customer->send_otp_token( $auth_type, null ), true );
		if ( strcasecmp( $content['status'], 'SUCCESS' ) == 0 ) {
			$db    = JFactory::getDbo();
			$query = $db->getQuery( true );
			$query->select( 'email_count' );
			$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
			$query->where( $db->quoteName( 'id' ) . " = 1" );

			$db->setQuery( $query );
			$email_count = $db->loadResult();

			$customer_details = Mo_Sociallogin_Local_Util::getCustomerDetails();
			$email_count      = $customer_details['email_count'];
			$admin_email      = $customer_details['email'];

			if ( $email_count != '' ) {
				$email_count = $email_count + 1;
				$db          = JFactory::getDbo();
				$query       = $db->getQuery( true );
				$fields      = array(
					$db->quoteName( 'email_count' ) . ' = ' . $db->quote( $email_count ),
					$db->quoteName( 'transaction_id' ) . ' = ' . $db->quote( $content['txId'] ),
					$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_SUCCESS' )
				);
				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName( 'id' ) . ' = 1'
				);

				$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
				$db->setQuery( $query );
				$result = $db->execute();

				$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Another One Time Passcode has been sent <b>( ' . $email_count . ' )</b> to <b>' . ( $admin_email ) . '</b>. Please enter the OTP below to verify your email.' );

			} else {
				$db     = JFactory::getDbo();
				$query  = $db->getQuery( true );
				$fields = array(
					$db->quoteName( 'email_count' ) . ' = ' . $db->quote( 1 ),
					$db->quoteName( 'transaction_id' ) . ' = ' . $db->quote( $content['txId'] ),
					$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_SUCCESS' )
				);
				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName( 'id' ) . ' = 1'
				);

				$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
				$db->setQuery( $query );
				$result = $db->execute();
				$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'An OTP has been sent to <b>' . ( $admin_email ) . '</b>. Please enter the OTP below to verify your email.' );

			}

		} else if ( strcasecmp( $content['status'], 'CURL_ERROR' ) == 0 ) {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_FAILURE' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $content['statusMessage'], 'error' );

		} else {
			$db     = JFactory::getDbo();
			$query  = $db->getQuery( true );
			$fields = array(
				$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( 'MO_OTP_DELIVERED_FAILURE' )
			);
			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName( 'id' ) . ' = 1'
			);

			$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
			$db->setQuery( $query );
			$result = $db->execute();
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'There was an error in sending email. Please click on Resend OTP to try again.', 'error' );

		}
	}

	function cancelform() {
		$db     = JFactory::getDbo();
		$query  = $db->getQuery( true );
		$fields = array(
			$db->quoteName( 'email' ) . ' = ' . $db->quote( '' ),
			$db->quoteName( 'registration_status' ) . ' = ' . $db->quote( '' ),
			$db->quoteName( 'login_status' ) . ' = ' . $db->quote( false ),
			$db->quoteName( 'email_count' ) . ' = ' . $db->quote( '' ),
			$db->quoteName( 'sms_count' ) . ' = ' . $db->quote( '' ),
		);
		// Conditions for which records should be updated.
		$conditions = array(
			$db->quoteName( 'id' ) . ' = 1'
		);

		$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
		$db->setQuery( $query );
		$result = $db->execute();
		$this->setRedirect( 'index.php?option=com_miniorangesociallogin' );

	}

	function phoneVerification() {
		$phone = $_POST['phone_number'];
		$phone = str_replace( ' ', '', $phone );

		$pattern = "/[\+][0-9]{1,3}[0-9]{10}/";

		if ( preg_match( $pattern, $phone, $matches, PREG_OFFSET_CAPTURE ) ) {
			$auth_type         = 'SMS';
			$customer          = new Mo_Sociallogin_Local_Customer();
			$send_otp_response = json_decode( $customer->send_otp_token( $auth_type, $phone ) );
			if ( $send_otp_response->status == 'SUCCESS' ) {
				$db    = JFactory::getDbo();
				$query = $db->getQuery( true );
				$query->select( 'sms_count' );
				$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
				$query->where( $db->quoteName( 'id' ) . " = 1" );

				$db->setQuery( $query );
				$sms_count = $db->loadResult();
				if ( $sms_count != '' ) {
					$sms_count = $sms_count + 1;
					$db        = JFactory::getDbo();
					$query     = $db->getQuery( true );
					$fields    = array(
						$db->quoteName( 'sms_count' ) . ' = ' . $db->quote( $sms_count ),
						$db->quoteName( 'transaction_id' ) . ' = ' . $db->quote( $send_otp_response->txId )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();

					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Another One Time Passcode has been sent <b>(' . $sms_count . ')</b> for verification to ' . $phone );


				} else {
					$db     = JFactory::getDbo();
					$query  = $db->getQuery( true );
					$fields = array(
						$db->quoteName( 'sms_count' ) . ' = ' . $db->quote( 1 ),
						$db->quoteName( 'transaction_id' ) . ' = ' . $db->quote( $send_otp_response->txId )
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName( 'id' ) . ' = 1'
					);

					$query->update( $db->quoteName( '#__miniorangesociallogin_customer_details' ) )->set( $fields )->where( $conditions );
					$db->setQuery( $query );
					$result = $db->execute();
					$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'One Time Passcode has been sent ( <b>1</b> ) for verification to ' . $phone );
				}

			}
		} else {

			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', 'Please enter the phone number in the following format: <b>+##country code## ##phone number##', 'error' );
		}
	}

	function forgotPassword() {
		//$admin_email = get_option('mo_sociallogin_local_admin_email');
		$db    = JFactory::getDbo();
		$query = $db->getQuery( true );
		$query->select( 'email' );
		$query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
		$query->where( $db->quoteName( 'id' ) . " = 1" );

		$db->setQuery( $query );
		$admin_email = $db->loadResult();

		$customer                 = new Mo_Sociallogin_Local_Customer();
		$forgot_password_response = json_decode( $customer->mo_sociallogin_local_forgot_password( $admin_email ) );
		if ( $forgot_password_response->status == 'SUCCESS' ) {
			$message = 'You password has been reset successfully. Please enter the new password sent to your registered mail here.';
			$this->setRedirect( 'index.php?option=com_miniorangesociallogin', $message );

		}
	}

}




?>