<?php
/** miniOrange enables user to log in using sociallogin credentials.
    Copyright (C) 2015  miniOrange

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange OAuth
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
/**
This class contains all the utility functions

**/
defined('_JEXEC') or die;
class Mo_Sociallogin_Local_Util{

	public static function is_customer_registered() {

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$result = $db->loadAssoc();
		
		$email 			= $result['email'];
		$customerKey 	= $result['customer_key'];
		if( ! $email || ! $customerKey || ! is_numeric( trim( $customerKey ) ) ) {
			return 0;
		} else {
			return 1;
		}
	}
	
	public static function check_empty_or_null( $value ) {
		if( ! isset( $value ) || empty( $value ) ) {
			return true;
		}
		return false;
	}
	
	public static function is_curl_installed() {
		if  (in_array  ('curl', get_loaded_extensions())) {
			return 1;
		} else 
			return 0;
	}
	
	public static function is_extension_installed($name) {
		if  (in_array  ($name, get_loaded_extensions())) {
			return true;
		}
		else {
			return false;
		}
	}
	
	public static function encrypt($str){
		$str = stripcslashes($str);
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('customer_token');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$key = $db->loadResult();
		
		$key    = openssl_digest($key, 'sha256');
		$method = 'AES-128-ECB';
		$ivSize = openssl_cipher_iv_length($method);
		$iv     = openssl_random_pseudo_bytes($ivSize);
		$strCrypt = openssl_encrypt ($str, $method, $key,OPENSSL_RAW_DATA||OPENSSL_ZERO_PADDING, $iv);
		return base64_encode($iv.$strCrypt);
		
	}
	
	public static function decrypt($data)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('customer_token');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$key = $db->loadResult();
		
		$strIn = base64_decode($data);
		$key    = openssl_digest($key, 'sha256');
		$method = 'AES-128-ECB';
		$ivSize = openssl_cipher_iv_length($method);
		$iv     = substr($strIn,0,$ivSize);
		$data   = substr($strIn,$ivSize);
		$clear  = openssl_decrypt ($data, $method, $key, OPENSSL_RAW_DATA||OPENSSL_ZERO_PADDING, $iv);

		return $clear;
	}
	
	public static function getHostname(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('hostname');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$hostname = $db->loadResult();
		return $hostname;
	}
	
	public static function getCustomertoken(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('customer_token');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$customer_token = $db->loadResult();
		return $customer_token;
	}
	
	public static function getCustomerKey(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('customer_key');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$customer_key = $db->loadResult();
		return $customer_key;
	}
	
	public static function getCustomerDetails(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from($db->quoteName('#__miniorangesociallogin_customer_details'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$customer_details = $db->loadAssoc();
		return $customer_details;
	}
	
	public static function getDefaultConfig(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$default_config = $db->loadAssoc();
		return $default_config;
	}
	
	public static function getLoginRequests(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('enable_log_requests');
		$query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$enable_log_requests = $db->loadResult();
		return $enable_log_requests;
	}
	
	public static function getServerurl(){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('server_url');
		$query->from($db->quoteName('#__miniorangesociallogin_apps_save'));
		$query->where($db->quoteName('id')." = 1");
 
		$db->setQuery($query);
		$server_url = $db->loadResult();
		return $server_url;
	}
	
}
?>