<?php
/*
* @version 1.0
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @author miniOrange (info@xecurify.com )
* @description >miniOrange Social Login, Sharing and Commenting module allows users to share your content to social sites like Facebook, Google +, Twitter, LinkedIn etc.
*/
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once dirname( __FILE__ ) . '/helper.php';

require_once JPATH_BASE . '/includes/framework.php';
require_once JPATH_BASE.DIRECTORY_SEPARATOR.'administrator'.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorangesociallogin'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'Mo_Openid_Twitter_OAuth.php';


$type = ModSocialloginHelper::getType();
if($type==null)
    $type='login';
$return = ModSocialloginHelper::getReturnURL( $params, $type );

$user   = JFactory::getUser();
require JModuleHelper::getLayoutPath( 'mod_miniorangesociallogin', $params->get( 'layout', 'default' ) );


 function mo_openid_login_validate() {
   
    // if customer is registered
    // retrieve app name 
    // call endpoint of access token
    $app = JFactory::getApplication();
    $get = $app->input->get->getArray();
    if(array_key_exists('oauth_token', $get) && array_key_exists('oauth_verifier', $get) ){
        $appDetails = getAppConfigurations('twitter');
            $twitterOauth = new Mo_Openid_Twitter_OAuth($appDetails['clientId'],$appDetails['clientSecret']);
            $twitter_access_token =$twitterOauth->mo_twitter_get_access_token($get['oauth_verifier'],$get['oauth_token']);
            $oauth_credentials = explode('=',$twitter_access_token);
           
            if(count(explode('=',$twitter_access_token))==5){
                    $oauth_token=explode('&oauth_token_secret',$oauth_credentials[1])[0];
                    $oauth_token_secret=explode('&user_id',$oauth_credentials[2])[0];
                    $screen_name = $oauth_token_secret[4];
            }
            $twitterProfileInfo = $twitterOauth->mo_twitter_get_profile_signature($oauth_token,$oauth_token_secret,$screen_name);
            $twitterProfileInfo = moSocialGetUserNameAndEmail('twitter',$twitterProfileInfo);
            moSocialUserLogin($twitterProfileInfo);
            
    }
    if(array_key_exists('option1', $get) && array_key_exists('mo_social_app_name_login', $get)){
        if(isCustomerRegistered()){
            $appname    = $get['mo_social_app_name_login'];
            $appDetails = getAppConfigurations($appname);

            if( $appDetails!==FALSE ){
                 if($appname == 'twitter' && $appDetails['preconfigured']!='1' ){
                    $twitterOauth = new Mo_Openid_Twitter_OAuth($appDetails['clientId'],$appDetails['clientSecret']);
                    $oauthToken = $twitterOauth->mo_twitter_get_request_token();
                    
                    $login_dialog_url = "https://api.twitter.com/oauth/authenticate?oauth_token=" . $oauthToken;
                    header('Location:'. $login_dialog_url);
      
                    exit;
                
                }
                else if($appDetails['preconfigured']=='1'){
                    // invoke preconfigured one
                    //getAccessCode($appDetails);
                    mo_openid_initialize_social_login($appname);


                }
                else{
                    getAccessCode($appDetails);
                    // invoke with custom clientId & clientSecret
                }
            }

        }   
    }
    if(array_key_exists('mojoomlassotag', $get)){
        $cusomerInfo = getCustomerDetails(); 
        $moUserInfo = array();
        
        foreach ($_REQUEST as $key => $value) {
            # code...
            $moUserInfo[$key] = decrypt_data($value,$cusomerInfo['customer_token']);
        }
       
         $userInfoArray = moSocialGetUserNameAndEmail($_REQUEST['mojoomlassotag'],$moUserInfo,TRUE);
         moSocialUserLogin($userInfoArray);
        
    }
    if(array_key_exists('code', $get) && array_key_exists('openidcallback', $get)){
       $accessTokenResult = getAccessToken($get['openidcallback'],$get['code']);
       if($get['openidcallback']=='yahoo')
         $moUserInfo = getResourceOwnerFromIdToken($accessTokenResult['id_token']);
       else{
            $accessToken = $accessTokenResult['access_token'];
            $moUserInfo = moGetUserInfo($get['openidcallback'],$accessToken);
       }

          
       $userInfoArray = moSocialGetUserNameAndEmail($get['openidcallback'],$moUserInfo);
       moSocialUserLogin($userInfoArray);
       
    }

}
function mo_openid_initialize_social_login($appName){
    $client_name = "wordpress";
    $timestamp   = round( microtime( true ) * 1000 );
    $cusomerInfo = getCustomerDetails();  
    $api_key     = $cusomerInfo['api_key'];
    $token       = $client_name . ':' . number_format( $timestamp, 0, '', '' ) . ':' . $api_key;
    $hostname    = 'https://login.xecurify.com';

        $customer_token  = $cusomerInfo['customer_token'];
        $encrypted_token = encrypt_data( $token, $customer_token );
        $encoded_token   = urlencode( $encrypted_token );

        $http            = isset( $_SERVER['HTTPS'] ) && ! empty( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] != 'off' ? "https://" : "http://";
        $base_return_url = $http . $_SERVER["HTTP_HOST"] . strtok( $_SERVER["REQUEST_URI"], '?' ); //. $post;
        $return_url      = strpos( $base_return_url, '?' ) !== false ? urlencode( $base_return_url . '&tag=sso' ) : urlencode( $base_return_url . '?mojoomlassotag='.$appName );
        $url             = $hostname . '/moas/openid-connect/client-app/authenticate?token=' . $encoded_token . '&id=' . $cusomerInfo['customer_key'] . '&encrypted=true&app=' . $appName . '_oauth_xecurify&returnurl=' . $return_url . '&encrypt_response=true';

        header( 'Location: ' . $url );
    exit;
}
function getResourceOwnerFromIdToken($id_token){
        $id_array = explode(".", $id_token);
        if(isset($id_array[1])) {
            $id_body = base64_decode($id_array[1]);
            if(is_array(json_decode($id_body, true))){
                return json_decode($id_body,true);
            }
        }
        echo 'Invalid response received.<br><b>Id_token : </b>'.$id_token;
        exit;
    }


function get_user_from_joomla( $matcher, $username, $email ) {
    //Check if email exist in database
    $db = JFactory::getDBO();

    switch ( $matcher ) {
        case 'username':
            $query = $db->getQuery( true )
                ->select( 'id' )
                ->from( '#__users' )
                ->where( 'username=' . $db->quote( $username ) );

            break;
        case 'email':
            $query = $db->getQuery( true )
                ->select( 'id' )
                ->from( '#__users' )
                ->where( 'email=' . $db->quote( $email ) );
            break;
        case 'usernameAndemail':
            $query = $db->getQuery( true )
                ->select( 'id' )
                ->from( '#__users' )
                ->where( 'email=' . $db->quote( $email ) && 'username=' . $db->quote( $username ) );
            break;
        default:
            $query = $db->getQuery( true )
                ->select( 'id' )
                ->from( '#__users' )
                ->where( 'email=' . $db->quote( $email ) );


            break;
    }

    $db->setQuery( $query );
    $result = $db->loadResult();
    return $result;

}

function mo_openid_decrypt( $param ) {
    $db    = JFactory::getDbo();
    $query = $db->getQuery( true );
    $query->select( '*' );
    $query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
    $query->where( $db->quoteName( 'id' ) . " = 1" );

    $db->setQuery( $query );
    $default_config = $db->loadAssoc();
    if ( strcmp( $param, 'null' ) != 0 && strcmp( $param, '' ) != 0 ) {
        $customer_token  = $default_config['customer_token'];
        $decrypted_token = decrypt_data( $param, $customer_token );
        // removes control characters and some blank characters
        $decrypted_token_sanitise = preg_replace( '/[\x00-\x1F][\x7F][\x81][\x8D][\x8F][\x90][\x9D][\xA0][\xAD]/', '', $decrypted_token );

        //strips space,tab,newline,carriage return,NUL-byte,vertical tab.
        return trim( $decrypted_token_sanitise );
    } else {
        return '';
    }
}

function encrypt_data( $data, $key ) {

    return base64_encode( openssl_encrypt( $data, 'aes-128-ecb', $key, OPENSSL_RAW_DATA ) );

}

function decrypt_data( $data, $key ) {

    return openssl_decrypt( base64_decode( $data ), 'aes-128-ecb', $key, OPENSSL_RAW_DATA );

}
function isCustomerRegistered(){
    $details = getCustomerDetails();
    if(isset($details['customer_token']) && isset($details['customer_key']) && !empty($details['customer_token']) && !empty($details['customer_key'])){
        return TRUE;
    }
    return FALSE;

}

function getAccessToken($appName,$code){
    $uri = JUri::current();
    $social_app_redirect_uri = $uri . '?openidcallback='.$appName;
    $appDetails = getAppConfigurations($appName);
    if($appDetails!==FALSE){
        $client_id        = $appDetails['clientId'];
        $client_secret    = $appDetails['clientSecret'];
       
        $access_token_uriArray = array('linkedin'=>'https://www.linkedin.com/oauth/v2/accessToken','google'=>'https://accounts.google.com/o/oauth2/token','instagram'=>'https://api.instagram.com/oauth/access_token','facebook'=>'https://graph.facebook.com/v2.11/oauth/access_token','yahoo'=>'https://api.login.yahoo.com/oauth2/get_token');
        $access_token_uri = $access_token_uriArray[$appName];
        $grant_type = 'authorization_code';  

     $ch = curl_init();                    // Initiate cURL
     curl_setopt( $ch, CURLOPT_URL, $access_token_uri );
     curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
     curl_setopt( $ch, CURLOPT_ENCODING, "" );
     curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
     curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
     curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
     curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
     curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
     curl_setopt( $ch, CURLOPT_POST, 1 );  // Tell cURL you want to post something
     curl_setopt( $ch, CURLOPT_HEADER, 0 );
     //curl_setopt( $ch, CURLOPT_POSTFIELDS, $postData ); // Define what you want to post
     curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true ); // Return the output in string format
     curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Authorization: Basic ' . base64_encode( $client_id . ":" . $client_secret ),
                    'Accept: application/json'
                ));
     curl_setopt( $ch, CURLOPT_POSTFIELDS, 'redirect_uri='.urlencode($social_app_redirect_uri).'&grant_type='.$grant_type.'&client_id='.$client_id.'&client_secret='.$client_secret.'&code='.$code);

     $result = curl_exec( $ch );

     if ( curl_errno( $ch ) ) {
         echo 'Request Error:' . curl_error( $ch );
         exit();
     }
     print_r(json_decode($result,true));

    
     return json_decode($result,true);
     
    }
   

}
function moGetUserInfo($appName,$accessToken){
    $profileUrlsArray = array('google'=>array('https://www.googleapis.com/oauth2/v1/userinfo?access_token='),'linkedin'=>array('https://api.linkedin.com/v2/me?projection=(id,firstName,lastName,emailAddress,profilePicture(displayImage~:playableStreams))','https://api.linkedin.com/v2/emailAddress?q=members&projection=(elements*(handle~))'),'instagram'=>array('https://graph.instagram.com/me?fields=id,username&access_token='.$accessToken),
        'facebook'=>array('https://graph.facebook.com/me/?fields=age_range,birthday,about,cover,currency,devices,education,email,favorite_athletes,favorite_teams,first_name,gender,hometown,inspirational_people,interested_in,is_verified,languages,last_name,link,locale,location,meeting_for,middle_name,name,name_format,political,public_key,quotes,relationship_status,religion,sports,timezone,updated_time,verified,website,work,friends,picture.height(180)&access_token='  .$accessToken)
    ); 
    $profile_json_output = array();
    foreach ($profileUrlsArray[$appName] as $key => $value) {
     
        $profile_json_output = array_merge($profile_json_output,getResourceOwner($value,$accessToken));
        # code...
    }

     return $profile_json_output;
}
function getResourceOwner($resourceownerdetailsurl, $access_token){
    echo $access_token;
    echo $resourceownerdetailsurl;

            $ch = curl_init($resourceownerdetailsurl);
            curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
            curl_setopt( $ch, CURLOPT_ENCODING, "" );
            curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
            curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
            curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
            curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
            curl_setopt( $ch, CURLOPT_POST, false);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Authorization: Bearer '.$access_token
            ));
            $t_vers = curl_version();
            curl_setopt( $ch, CURLOPT_USERAGENT, 'curl/' . $t_vers['version']);
            $content = curl_exec($ch);
            if(curl_error($ch)){
                exit( curl_error($ch) );
            }
            if(!is_array(json_decode($content, true))) {
                exit("Invalid response received.");
            }
            $content = json_decode($content,true);
            if(isset($content["error_description"])){
                if(is_array($content["error_description"]))
                    print_r($content["error_description"]);
                else
                    echo $content["error_description"];
                exit;
            } else if(isset($content["error"])){
                if(is_array($content["error"]))
                    print_r($content["error"]);
                else
                    echo $content["error"];
                exit;
            }
           
            return $content;
        }




function getAccessCode( $appDetails ){

    $http = isset( $_SERVER['HTTPS'] ) && ! empty( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] != 'off' ? "https://" : "http://";
    $base_return_url = $http . $_SERVER["HTTP_HOST"] . strtok( $_SERVER["REQUEST_URI"], '?' ); //. $post;
    $appName = $appDetails['appName'];
   
               
        $client_Secret = $appDetails['clientSecret'];
        $client_id     = $appDetails['clientId'];
        $scope         = $appDetails['scope'];
        
        $social_app_redirect_uri = $base_return_url . '?openidcallback='.$appName;
            
        $login_dialog_url =getLoginDialogUrl($appName,$client_id,$social_app_redirect_uri,$scope);

            
        header( 'Location: ' . $login_dialog_url );
        exit;
}

function getLoginDialogUrl($appName,$client_id,$social_app_redirect_uri,$scope){
    switch($appName){
        case 'google':
                        {
                            return 'https://accounts.google.com/o/oauth2/auth?redirect_uri=' .$social_app_redirect_uri .'&response_type=code&client_id=' .$client_id .'&scope='.$scope.'&access_type=offline';
                            break;

                        }
        case 'facebook':{
                            return  "https://www.facebook.com/v2.11/dialog/oauth?client_id=".$client_id. '&redirect_uri='. $social_app_redirect_uri .'&response_type=code&scope='.$scope;
                            break;
                        }
         case 'linkedin':{
                            return 'https://www.linkedin.com/oauth/v2/authorization?response_type=code&client_id='.$client_id.'&redirect_uri=' . $social_app_redirect_uri .'&state=fooobar&scope=' . $scope;
                            break;  
                        }
        case 'instagram':{
                            return 'https://api.instagram.com/oauth/authorize/?client_id=' . $client_id . '&redirect_uri=' . $social_app_redirect_uri . '&scope='.$scope.'&response_type=code';
                            break;  
                        }
        case 'yahoo':{
                        return 'https://api.login.yahoo.com/oauth2/request_auth?client_id=' . $client_id . '&response_type=code&scope='.$scope.'&redirect_uri='.$social_app_redirect_uri.'&state=RGVlcGFreWFob28=';
                        break;
                    }
    }
   
}

function moSocialGetUserNameAndEmail($appName,$userInfo,$isPreconfigured = FALSE){
    
    $username = '';
    $email = '';
    if($isPreconfigured){
        $profileAttributeArray = array(
            'google'=>array('username'=>array('email'),'email'=>array('email')),
            'linkedin'=>array('username'=>array('email'),'email'=>array('email')),
            'facebook'=>array('username'=>array('username'),'email'=>array('email'),),
            'twitter'=>array('username'=>array('email'),'email'=>array('email')),
            'yahoo'=>array('username'=>array('username'),'email'=>array('email'))

        );
    }

    else
    {
        $profileAttributeArray = array(
            'google'=>array('username'=>array('name'),'email'=>array('email')),
            'linkedin'=>array('username'=>array('firstName','localized','en_US'),'email'=>array('elements','0','handle~','emailAddress')),
            'facebook'=>array('username'=>array('name'),'email'=>array('email'),),
            'twitter'=>array('username'=>array('name'),'email'=>array('email')),
            'yahoo'=>array('username'=>array('name'),'email'=>array('email'))

        );

    }
    
    $userNameIndex = $profileAttributeArray[$appName]['username'];
    $emailIndex    =  $profileAttributeArray[$appName]['email'];
    foreach ($profileAttributeArray[$appName]['username'] as $key => $value) {
       if(empty($username))
        $username = $userInfo[$value];
       else
        $username = $username[$value];

    }
    foreach ($profileAttributeArray[$appName]['email'] as $key => $value) {
      if(empty($email))
        $email = $userInfo[$value];
       else
        $email = $email[$value];
    }
    
    return array('userName'=>$username,'email'=>$email);
}

function moSocialUserLogin($userInfo){
    $userId = get_user_from_joomla('email',$userInfo['userName'],$userInfo['email']);
    if( is_null($userId) || $userId==0){
        moSocialCreateUser($userInfo);
        $userId = get_user_from_joomla('email',$userInfo['userName'],$userInfo['email']); 
    }
    
    $app = JFactory::getApplication();
    if($userId !=0 ){
        $current_user = JFactory::getUser($userId);
        echo $userId;
        JPluginHelper::importPlugin('user');
        $options = array();
        $options['action'] = 'core.login.site';
        $response = new stdClass();
        $response->username = $current_user->username;
        $response->language = '';
        $response->email = $current_user->email;
        $response->password_clear = '';
        $response->fullname = '';
        $result = $app->triggerEvent('onUserLogin', array((array)$response, $options));
        

        if(in_array(false,$result)){
            $app->logout($current_user->id);
            $app->redirect('index.php', "facing issues while login", 'error');
            return;
        }

    }
    
    $app->redirect('index.php', "Welcome ".$current_user->username, 'message');
    return;
}

function moSocialCreateUser($userInfo){
    
     jimport( 'joomla.user.authentication' );
   
  
     $default_group = 2;
    $data['name']       = $userInfo['email'];
    $data['username']   = $userInfo['userName'];
    $data['email']      = $data['email1'] = $data['email2'] = JStringPunycode::emailToPunycode( $userInfo['email'] );
    $data['password']   = $data['password1'] = $data['password2'] = JUserHelper::genRandomPassword();
    $data['activation'] = '0';
    $data['block']      = '0';
    $data['groups'][] = $default_group;


    jimport( 'joomla.application.component.model' );

    if ( ! defined( 'JPATH_COMPONENT' ) ) {
        define( 'JPATH_COMPONENT', JPATH_BASE . '/components/' );
    }

    $user = new JUser;

    if ( ! $user->bind( $data ) ) {
        throw new Exception( "Could not bind data. Error: " . $user->getError() );
    }

    if ( ! $user->save() ) {
        throw new Exception( "Could not save user. Error: " . $user->getError() );
    }
}






function getCustomerDetails(){
    $db    = JFactory::getDbo();
    $query = $db->getQuery( true );
    $query->select( '*' );
    $query->from( $db->quoteName( '#__miniorangesociallogin_customer_details' ) );
    $query->where( $db->quoteName( 'id' ) . " = 1" );

    $db->setQuery( $query );
    return $db->loadAssoc();

}
function getAppConfigurations($appName){
    $db    = JFactory::getDbo();
    $query = $db->getQuery( true );
    $query->select( '*' );
    $query->from( $db->quoteName( '#__miniorangesociallogin_apps_data' ) );
    $query->where( $db->quoteName( 'appName' ) . " =".$db->quote($appName) );

    $db->setQuery( $query );
    $result = $db->loadAssoc();
    if( is_null($result) ){
        return FALSE;
    }
    return $result;
}

?>